//THINGS DO TO:
//Remove commentaries in parascan

#include <STDIO.H>
#include "COMMON.H"

#define MAXTILES 9216

LPDIRECTDRAW				lpDD;
LPDIRECTDRAWSURFACE			lpPrimary;
LPDIRECTDRAWSURFACE			lpBackBuffer;
extern XBUILD_MAP			SOFT_Map;
extern unsigned char *		pVideoBuffer;
int							nCX;
int							nCY;
XBUILD_ART_TILEDATA*		SOFT_Tiles[MAXTILES];
HANDLE						SOFT_hModule;
extern SOFT_CONFIG			SOFT_Config;
int							SOFT_nColorDepth = 0;
unsigned long*				SOFT_pConvertionBuffer;
unsigned char				SOFT_pPalette[0x300];
HWND						SOFT_hWnd;

int SOFT_nResX[4] =
{
	320,
	640,
	800,
	1024
};

int SOFT_nResY[4] =
{
	240,
	480,
	600,
	768
};

#pragma intrinsic(memcpy)
#pragma intrinsic(memset)

#define DLLEXPORT __declspec(dllexport)

int				setgamemode(long, long);
void			drawline256(long x1, long y1, long x2, long y2, char col);
void			printext256(long xpos, long ypos, short col, short backcol, char name[82], char fontsize);
void			drawmapview(long dax, long day, long zoome, short ang);
void			initspritelists();
short			insertsprite(short sectnum, short statnum);
void			drawrooms(long daposx, long daposy, long daposz, short daang, long dahoriz, short dacursectnum);
extern "C" int	detectmmx();

int GetColorDepth()
{
	DDSURFACEDESC ddsd;
	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(DDSURFACEDESC);
	lpDD->GetDisplayMode(&ddsd);
	switch(ddsd.ddpfPixelFormat.dwRBitMask)
	{
	case 0x00FF0000:
		//Not sure of this one	
		if(ddsd.ddpfPixelFormat.dwAlphaBitDepth)
		{
			return 32;
		}
		else
		{
			return 24;
		}
		break;
	case 0x0000F800:
		return 16;
		break;
	case 0x00007C00:
		return 15;
		break;
	default:
		return 8;
		break;
	}
	return 0;
}

void center_window(HWND hWnd)
{
	int resx = GetDeviceCaps(GetDC(hWnd), HORZRES);
	int resy = GetDeviceCaps(GetDC(hWnd), VERTRES);
	int wndx;
	int wndy;
	RECT wnd;
	GetWindowRect(hWnd, &wnd);
	wndx = wnd.right - wnd.left;
	wndy = wnd.bottom - wnd.top;
	SetWindowPos(hWnd, NULL, (resx - wndx) / 2, (resy - wndy) / 2, NULL, NULL, SWP_NOZORDER | SWP_NOSIZE);
}

extern "C" int Initialize(HWND hWnd)
{
	DDSURFACEDESC ddsd;
	LPDIRECTDRAWPALETTE lpP;
	PALETTEENTRY pe[256];
	LPDIRECTDRAWCLIPPER lpDDC;
	unsigned _int8 *pPalette;
	int i;
	CONFIG_LoadConfiguration();
	nCX = SOFT_nResX[SOFT_Config.nVideoMode];
	nCY = SOFT_nResY[SOFT_Config.nVideoMode];
	DirectDrawCreate(NULL, &lpDD, NULL);
	if(lpDD == NULL)
	{
		return 0;
	}
	if(SOFT_Config.n2xSaI)
	{
		lpDD->SetCooperativeLevel(hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN);
		lpDD->SetDisplayMode(nCX, nCY, 16);
	}
	else if(SOFT_Config.nFullscreen)
	{
		lpDD->SetCooperativeLevel(hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN);
		lpDD->SetDisplayMode(nCX, nCY, 8);
	}
	else
	{
		RECT rc;
		SetWindowPos(hWnd, NULL, 0, 0, nCX, nCY, SWP_NOMOVE);
		GetClientRect(hWnd, &rc);
		center_window(hWnd);
		nCX = rc.right;
		nCY = rc.bottom;
		lpDD->SetCooperativeLevel(hWnd, DDSCL_NORMAL);
		lpDD->CreateClipper(0, &lpDDC, NULL);
		lpDDC->SetHWnd(0, hWnd);
	}
	SOFT_nColorDepth = GetColorDepth();
	SOFT_hWnd = hWnd;
	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(DDSURFACEDESC);
	ddsd.dwFlags = DDSD_CAPS;
	ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
	lpDD->CreateSurface(&ddsd, &lpPrimary, NULL);
	setgamemode(nCX, nCY);
	memset(SOFT_Tiles, 0, sizeof(XBUILD_ART_TILEDATA*) * MAXTILES);
	if(SOFT_Config.nFullscreen)
	{
		pPalette = new unsigned _int8[0x300];
		XBUILD_ART_GetPalette(pPalette);
		for(i = 0; i < 256; i++)
		{
			pe[i].peRed		= pPalette[(i * 3) + 0] << 2;
			pe[i].peGreen	= pPalette[(i * 3) + 1] << 2;
			pe[i].peBlue	= pPalette[(i * 3) + 2] << 2;
			pe[i].peFlags	= 0;
		}
		delete pPalette;
		lpDD->CreatePalette(DDPCAPS_8BIT | DDPCAPS_ALLOW256, pe, &lpP, NULL);
		lpPrimary->SetPalette(lpP);
		lpP->Release();
	}
	else
	{
		SOFT_pConvertionBuffer = new unsigned long[nCX * nCY];
		XBUILD_ART_GetPalette(SOFT_pPalette);
		lpPrimary->SetClipper(lpDDC);
		lpDDC->Release();
		lpDDC = NULL;
	}
	return 1;
}

extern "C" void Destroy()
{
	int i;
	if(lpDD != NULL)
	{
		if(lpPrimary != NULL)
		{
			lpPrimary->Release();
			lpPrimary = NULL;
		}
		lpDD->RestoreDisplayMode();
		lpDD->Release();
		lpDD = NULL;
	}
	delete pVideoBuffer;
	if(!SOFT_Config.nFullscreen)
	{
		delete SOFT_pConvertionBuffer;
	}
	for(i = 0; i < MAXTILES; i++)
	{
		if(SOFT_Tiles[i] != NULL)
		{
			delete SOFT_Tiles[i];
		}
	}
}

extern "C" void Config()
{
	CONFIG_Start();
}

extern "C" void About()
{
	char str[256];
	sprintf(str, "Software Renderer %s\n\nOriginal code by:\nKen Silverman\n\nAdapted for the xBUILD engine by:\nJean-Philip Desjardins\n", VERSION);
	MessageBox(NULL, str, "About", MB_ICONINFORMATION);
}

extern "C" void *GetMapAddress()
{
	return &SOFT_Map;
}

extern "C" void PrepareMap(void *pMap)
{
	int i;
	initspritelists();
	memcpy(&SOFT_Map, pMap, sizeof(XBUILD_MAP));
	SOFT_Map.Mapinfo.StartZ <<= 4;
	for(i = 0; i < SOFT_Map.Mapinfo.SectorNumber; i++)
	{
		SOFT_Map.Sector[i].CZ <<= 4;
		SOFT_Map.Sector[i].FZ <<= 4;
	}
	for(i=0;i<SOFT_Map.Mapinfo.SpriteNumber;i++)
	{
		SOFT_Map.Sprite[i].Z <<= 4;
		insertsprite(SOFT_Map.Sprite[i].SectorNum,SOFT_Map.Sprite[i].StatNum);
	}
}

extern "C" void DrawMap(int X, int Y, int Z, int nXRot, int nYRot)
{
	char strText[256];
	sprintf(strText, "X: %i, Y: %i, Z: %i, A: %i", X, Z, Y, nYRot);
	memset(pVideoBuffer, 0, nCX * nCY);
	drawrooms(X, Z, Y, nYRot, 100, 0);
	//drawmapview(X, Z, 1000, nYRot);
	printext256(0, 0, 63, -1, strText, 0);
}

void Blit32(unsigned long *lpBuffer, long dwPitch)
{
	unsigned char bColor;
	int i;
	for(i = 0; i < nCX * nCY; i++)
	{
		bColor = pVideoBuffer[i];
		SOFT_pConvertionBuffer[i] =	0x00000000								|
									(SOFT_pPalette[(bColor * 3) + 0] << 18) |
									(SOFT_pPalette[(bColor * 3) + 1] << 10)	|
									(SOFT_pPalette[(bColor * 3) + 2] << 2);
	}
	for(i = 0; i < nCY; i++)
	{
		memcpy(lpBuffer, SOFT_pConvertionBuffer + (nCX * i), nCX * 4);
		lpBuffer += (dwPitch / 4);
	}
}

extern "C" void SwapDisplayBuffers()
{
	DDSURFACEDESC ddsd;
	unsigned long *lpBuffer;
	int i;
	RECT rc;
	POINT pt;
	memset(&ddsd, 0, sizeof(DDSURFACEDESC));
	ddsd.dwSize = sizeof(DDSURFACEDESC);
	if(SOFT_Config.nFullscreen)
	{
		lpPrimary->Lock(NULL, &ddsd, DDLOCK_WAIT | DDLOCK_NOSYSLOCK, NULL);
	}
	else
	{
		pt.x = 0;
		pt.y = 0;
		ClientToScreen(SOFT_hWnd, &pt);
		rc.left = pt.x;
		rc.top = pt.y;
		rc.right = rc.left + nCX;
		rc.bottom = rc.top + nCY;
		lpPrimary->Lock(&rc, &ddsd, DDLOCK_WAIT | DDLOCK_NOSYSLOCK, NULL);
	}
	if(ddsd.lpSurface != NULL)
	{
		lpBuffer = (unsigned long*)ddsd.lpSurface;
		switch(SOFT_nColorDepth)
		{
		case 8:
			for(i = 0; i < nCY; i++)
			{
				memcpy(lpBuffer, pVideoBuffer + (nCX * i), nCX);
				lpBuffer += ddsd.lPitch / 4;
			}
			break;
		case 32:
			Blit32(lpBuffer, ddsd.lPitch);
			break;
		}
	}
	lpPrimary->Unlock(NULL);
}

extern "C" void ProcessDisplayList(void*)
{

}

extern "C" int IsFullScreen()
{
	CONFIG_LoadConfiguration();
	if(SOFT_Config.nFullscreen)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

extern "C" int GetWidth()
{
	return 0;
}

extern "C" int GetHeight()
{
	return 0;
}

extern "C" void SetMeshToTile(int, char*, float)
{

}

extern "C" void TakeScreenShot(char *lpstrFilename)
{
	
}

XBUILDRENCONTEXT RendSoftContext =
{
	Initialize,
	Config,
	About,
	Destroy,
	DrawMap,
	PrepareMap,
	SwapDisplayBuffers,
	ProcessDisplayList,
	GetMapAddress,
	IsFullScreen,
	GetWidth,
	GetHeight,
	SetMeshToTile,
	TakeScreenShot,
	"Software Renderer",
	"Ken Silverman / Virtual Applications",
	VERSION
};

extern "C" void DLLEXPORT GetRendererContext(void* context)
{
	memmove(context, &RendSoftContext, sizeof(XBUILDRENCONTEXT));
}

BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	SOFT_hModule = hModule;
	return TRUE;
}