#include "COMMON.H"

int							VOGL_nSectorDL[MAXSECTORS][2];
extern XBUILD_MAP			VOGL_Map;
extern XBUILD_ART_TILEDATA*	VOGL_Tiles[MAXTILES];
int							VOGL_TessSect = 0;
int							VOGL_TessFloor = 0;

struct VERTEX
{
	double x;
	double y;
	double z;
};

void TessMapTexture(int sectnum, int nX, int nY, int nFloor)
{
	int maxX, maxY, minX, minY;
	int i, k;
	int dist1, dist2;
	float number;
	float U, V;
	maxX = maxY = 0x80000000;
	minX = minY = 0x7FFFFFFF;
	i = VOGL_Map.Sector[sectnum].WallPointer;
	for(k = 0; k < VOGL_Map.Sector[sectnum].WallNumber; k++)
	{
		if(VOGL_Map.Wall[i].X > maxX)
		{
			maxX = VOGL_Map.Wall[i].X;
		}
		if(VOGL_Map.Wall[i].X < minX)
		{
			minX = VOGL_Map.Wall[i].X;
		}
		if(VOGL_Map.Wall[i].Y > maxY)
		{
			maxY = VOGL_Map.Wall[i].Y;
		}
		if(VOGL_Map.Wall[i].Y < minY)
		{
			minY = VOGL_Map.Wall[i].Y;
		}
		i = VOGL_Map.Wall[i].Point2;
	}
	dist1 = maxX - minX;
	dist2 = nX - minX;

	if(nFloor)
	{
		//Floor U
		number = ((float)dist1 / (float)VOGL_Tiles[VOGL_Map.Sector[sectnum].FPic]->Width) / 16.0f;
		U = ((float)dist2 * number) / (float)dist1;
	}
	else
	{
		//Ceiling U
		number = ((float)dist1 / (float)VOGL_Tiles[VOGL_Map.Sector[sectnum].CPic]->Width) / 16.0f;
		U = ((float)dist2 * number) / (float)dist1;
	}


	dist1 = maxY - minY;
	dist2 = nY - minY;

	if(nFloor)
	{
		//Floor V
		number = ((float)dist1 / (float)VOGL_Tiles[VOGL_Map.Sector[sectnum].FPic]->Height) / 16.0f;
		V = ((float)dist2 * number) / (float)dist1;
	}
	else
	{
		//Ceiling V
		number = ((float)dist1 / (float)VOGL_Tiles[VOGL_Map.Sector[sectnum].CPic]->Height) / 16.0f;
		V = ((float)dist2 * number) / (float)dist1;
	}
	glTexCoord2f(U, V);

}

void WINAPI TessDrawVertex(VERTEX *v)
{
	TessMapTexture(VOGL_TessSect, (int)v->x, (int)v->z, VOGL_TessFloor);
	glVertex3i((int)v->x, (int)v->y, (int)v->z);
}

void GenerateList(int nSector, int nFloor, int *nList)
{
	GLUtesselator *t;
	int i, nContour;
	XBUILD_MAP_WALL *wall;
	VERTEX *v;
	t = gluNewTess();	
	*nList = glGenLists(1);
	glNewList(*nList, GL_COMPILE);
	//Shouldn't need to set the callbacks all the time
	gluTessCallback(t, GLU_TESS_BEGIN, (void (__stdcall*)(void))glBegin);
	gluTessCallback(t, GLU_TESS_VERTEX, (void (__stdcall*)(void))TessDrawVertex);
	gluTessCallback(t, GLU_TESS_END, glEnd);
	gluTessBeginPolygon(t, NULL);
		gluTessBeginContour(t);
			wall = &VOGL_Map.Wall[VOGL_Map.Sector[nSector].WallPointer];
			v = new VERTEX[VOGL_Map.Sector[nSector].WallNumber];
			nContour = VOGL_Map.Sector[nSector].WallPointer;
			VOGL_TessSect = nSector;
			VOGL_TessFloor = nFloor;
			for(i = 0; i < VOGL_Map.Sector[nSector].WallNumber; i++, wall++)
			{
				v[i].x = (double)wall->X;
				v[i].z = (double)wall->Y;
				if(nFloor)
				{
					v[i].y = (double)-XBUILD_ANIMATE_GetFloorHeight(nSector, (long)v[i].x, (long)v[i].z);
				}
				else
				{
					v[i].y = (double)-XBUILD_ANIMATE_GetCeilingHeight(nSector, (long)v[i].x, (long)v[i].z);
				}
				gluTessVertex(t, (double*)&v[i], (double*)&v[i]);
				if((wall + 1) != &VOGL_Map.Wall[wall->Point2])
				{
					gluTessEndContour(t);
					gluTessBeginContour(t);
					nContour = i + 1;
				}
			}
		gluTessEndContour(t);
	gluTessEndPolygon(t);
	gluDeleteTess(t);
	glEndList();
	delete v;
}

void CreateDisplayListForSector(int nSector)
{
	GenerateList(nSector, TRUE, &VOGL_nSectorDL[nSector][0]);
	GenerateList(nSector, FALSE, &VOGL_nSectorDL[nSector][1]);
}