// ScriptManager.cpp: implementation of the CScriptManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "glDuke.h"
#include "ScriptManager.h"
#include "..\XBUILD\XBUILD.H"
#include <MATH.H>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

int nThreadExecution = 0;
int *nThreadX;
int *nThreadY;
int *nThreadZ;
int	nScriptCount;

XBUILD_CONSCRIPT_CONTEXT *pThreadC;
CGame *pThreadGame;

int FunctionCallback(int nFunction, int nParam, XBUILD_MAP_SPRITE *pSprite)
{
	unsigned short wParam1;
	unsigned short wParam2;
	int nTemp;
	switch(nFunction)
	{
	case VM_ADDHEALTH:
		nParam = pThreadGame->nHealth + nParam;
		if(pSprite->Pic == 100)
		{
			if(nParam > pThreadGame->c->Gamestartup.nMaxPlayerHealth * 2)
			{
				nParam = pThreadGame->c->Gamestartup.nMaxPlayerHealth * 2;
			}
		}
		else
		{
			if(nParam > pThreadGame->c->Gamestartup.nMaxPlayerHealth)
			{
				nParam = pThreadGame->c->Gamestartup.nMaxPlayerHealth;
			}
		}
		pThreadGame->ChangeHealth(nParam);
		break;
	case VM_GETHEALTH:
		return pThreadGame->nHealth;
		break;
	case VM_GLOBALSOUND:
		int nSound;
		nSound = pThreadGame->GetCorrectSoundNumber(nParam);
		XBUILD_SOUND_Play(pThreadC->DefineSound[nSound].strFilename, 0);
		break;
	case VM_QUOTE:
		pThreadGame->PrintTextOnStatus(pThreadC->DefineQuote[nParam].strQuote);
		break;
	case VM_GETDISTANCE:
		float fX, fY, fZ, fDistance;
		fX = (float)*nThreadX - (float)pSprite->X;
		fY = (float)*nThreadY - (float)pSprite->Y;
		fZ = (float)*nThreadZ - (float)pSprite->Z;
		fDistance = (float)sqrt((fX * fX) + (fY * fY));
		if(abs((int)fZ) > 1000.0f)
		{
			return 0x7FFFFFFF;
		}
		return (int)fDistance;
		break;
	case VM_CANSEE:
		if(XBUILD_ANIMATE_CanSee(*nThreadX, *nThreadY, *nThreadZ, XBUILD_ANIMATE_GetCurrentSector(), pSprite->X, pSprite->Y, pSprite->Z, pSprite->SectorNum))
		{
			return 1;
		}
		break;
	case VM_ADDAMMO:
		wParam1 = nParam & 0xFFFF;
		wParam2 = (nParam >> 16) & 0xFFFF;
		pThreadGame->nWeaponsAmmo[wParam1] += wParam2;
		switch(wParam1)
		{
		case 1:
			nTemp = pThreadGame->c->Gamestartup.nMaxPistolAmmo;
			break;
		case 2:
			nTemp = pThreadGame->c->Gamestartup.nMaxShotgunAmmo;
			break;
		case 3:
			nTemp = pThreadGame->c->Gamestartup.nMaxChaingunAmmo;
			break;
		case 4:
			nTemp = pThreadGame->c->Gamestartup.nMaxRPGAmmo;
			break;
		case 5:
			nTemp = pThreadGame->c->Gamestartup.nMaxPipebombAmmo;
			break;
		case 6:
			nTemp = pThreadGame->c->Gamestartup.nMaxShrinkerAmmo;
			break;
		case 7:
			nTemp = pThreadGame->c->Gamestartup.nMaxDevastatorAmmo;
			break;
		case 8:
			nTemp = pThreadGame->c->Gamestartup.nMaxTripbombAmmo;
			break;
		case 9:
			nTemp = pThreadGame->c->Gamestartup.nMaxFreezeAmmo;
			break;
		case 11:
			nTemp = pThreadGame->c->Gamestartup.nMaxGrowAmmo;
			break;
		}
		if(pThreadGame->nWeaponsAmmo[wParam1] > nTemp)
		{
			pThreadGame->nWeaponsAmmo[wParam1] = nTemp;
		}
		break;
	}
	return 0;	
}

DWORD WINAPI ThreadExecution(void *lpParam)
{
	int i;
	int nCount;
	XBUILD_CONSCRIPTACTOR_CONTEXT **pActor;
	pActor = (XBUILD_CONSCRIPTACTOR_CONTEXT**)lpParam;
	XBUILD_CONVM_SetFunctionCallback((void*)FunctionCallback);
	while(!nThreadExecution)
	{
		nCount = nScriptCount;
		for(i = 0; i < 4096; i++)
		{
			if(nCount == 0) break;
			if(!pActor[i]) continue;
			XBUILD_CONVM_Execute(pActor[i]);
			if(pActor[i]->wHP == 0xFFFF)
			{
				memset(pActor[i]->pSprite, 0, sizeof(XBUILD_MAP_SPRITE));
				pActor[i]->pSprite->Pic = 0xFFFF;
				delete pActor[i];
				pActor[i] = NULL;
				nScriptCount--;
			}
			nCount--;
		}
		Sleep(200);
	}
	return 0xDEADBEEF;
}
 
CScriptManager::CScriptManager()
{
	memset(pActor, 0, sizeof(void*) * 4096);
}

CScriptManager::~CScriptManager()
{
	DeleteAll();
}

void CScriptManager::DeleteAll()
{
	int i;
	if(hThread)
	{
		nThreadExecution = 1;
		WaitForSingleObject(hThread, INFINITE);
		hThread = NULL;
	}
	for(i = 0; i < 4096; i++)
	{
		if(pActor[i])
		{
			delete pActor[i];
			pActor[i] = NULL;
		}
	}
}

void CScriptManager::FireAllScripts(XBUILD_CONSCRIPT_CONTEXT *c, int *nX, int *nY, int *nZ, CGame *pGame)
{
	int i, j;
	char strTemp[0x1000];
	XBUILD_MAP *m;
	pContext = c;
	pThreadC = c;
	m = (XBUILD_MAP*)XBUILD_GFX_GetMapAddress();
	XBUILD_CONACTORCOMPILER_SetConscriptContext(c);
	nThreadX = nX;
	nThreadY = nY;
	nThreadZ = nZ;
	pThreadGame = pGame;
	nScriptCount = 0;
	for(i = 0; i < m->Mapinfo.SpriteNumber; i++)
	{
		for(j = 0; j < c->nActorCount; j++)
		{
			if(c->Actor[j].nSprite == m->Sprite[i].Pic)
			{
				if(m->Sprite[i].Pic >= 0 && m->Sprite[i].Pic <= 120 && !(m->Sprite[i].CStat & 0x8000))
				{
					FILE *stream;
					pActor[i] = new XBUILD_CONSCRIPTACTOR_CONTEXT;
					memset(pActor[i], 0, sizeof(XBUILD_CONSCRIPTACTOR_CONTEXT));
					pActor[i]->pSprite = &m->Sprite[i];
					pActor[i]->wPlayerStatus = 0x4000;
					XBUILD_CONACTORCOMPILER_Assemble(j, pActor[i]->pCode);
					nScriptCount++;
					/*if(m->Sprite[i].Pic == 44)
					{
						XBUILD_CONVM_Disassemble(strTemp, pActor[i]->pCode, 0, 0x100);
						stream = fopen("CONPRG.TXT", "wb");
						fwrite(strTemp, 0x1000, 1, stream);
						fclose(stream);
					}*/
					break;
				}
			}
		}
	}
	nThreadExecution = 0;
	hThread = CreateThread(NULL, NULL, ThreadExecution, &pActor, NULL, &dwThreadID);
}