#include "COMMON.H"

struct INSTRUCTION
{
	const char *	strSyntax;
	int				nArgs;
};

struct SUBROUTINE
{
	int					nStartPos;
	int					nEndPos;
	int					nJMPAddress;
	int					nElseCase;
	unsigned _int8*		pScript;
};

unsigned _int8*				CAC_pScript = NULL;
unsigned _int8*				CAC_pCode;
XBUILD_CONSCRIPT_CONTEXT*	CAC_Context = NULL;
int							CAC_nPos = 0;
int							CAC_nScriptSize = 0;
int							CAC_nCodePos = 0;
int							CAC_nLastestSubroutine;
int							CAC_nSubCount;
int							CAC_nLastestAddress = 0;
SUBROUTINE					CAC_Subs[0x20];
void						CONACTORCOMPILER_CompileState(char*);

INSTRUCTION Instructions[0x40] =
{
	//0x00
	{ "nullop",			0 },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	//0x08
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	//0x10
	{ "addinventory",	2 },
	{ "addphealthl",	1 },
	{ "fall",			0 },
	{ "quote",			1 },
	{ "sound",			1 },
	{ "palfrom",		3 },
	{ "killit",			0 },
	{ "addweapon",		2 },
	//0x18
	{ "action",			1 },
	{ "spawn",			1 },
	{ "debris",			2 },
	{ "move",			1 },
	{ "addkills",		1 },
	{ "globalsound",	1 },
	{ "addammo",		2 },
	{ NULL,				NULL },
	//0x20
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	//0x28
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	{ NULL,				NULL },
	//0x30
	{ "ifaction",		1 },
	{ "ifactioncount",	1 },
	{ "ifrnd",			1 },
	{ "ifp",			1 },
	{ "ifcount",		1 },
	{ "ifpdistl",		1 },
	{ "ifpinventory",	2 },
	{ "ifspawnedby",	1 },
	//0x38
	{ "ifphealthl",		1 },
	{ "ifmove",			1 },
	{ "ifhitweapon",	0 },
	{ "ifdead",			0 },
	{ "ifactor",		1 },
	{ "ifcanseetarget",	0 },
	{ NULL,				NULL },
	{ NULL,				NULL },
};

__inline unsigned char CONACTORCOMPILER_GetByte()
{
	if(CAC_nPos >= CAC_nScriptSize)
	{
		return 0xFF;
	}
	return CAC_pScript[CAC_nPos++];
}

__inline void CONACTORCOMPILER_SetByte(unsigned char nByte)
{
	CAC_pCode[CAC_nCodePos++] = nByte;
}

__inline void CONACTORCOMPILER_SetWord(unsigned short wWord)
{
	CAC_pCode[CAC_nCodePos++] = wWord >> 8;
	CAC_pCode[CAC_nCodePos++] = wWord & 0xFF;
}

__inline unsigned short CONACTORCOMPILER_GetValue(char *lpstrString)
{
	int nValue;
	int i;
	for(i = 0; i < CAC_Context->nDefineCount; i++)
	{
		if(!strnicmp(lpstrString, CAC_Context->Define[i].strSymbol, strlen(lpstrString)))
		//Wierd thing here :(
		//if(!strcmp(lpstrString, CAC_Context->Define[i].strSymbol))
		{
			return CAC_Context->Define[i].nValue;
		}
	}
	sscanf(lpstrString, "%i", &nValue);
	return nValue;
}

int CONACTORCOMPILER_GetNextString(char *lpString)
{
	unsigned char nByte;
	int nStrPos = 0;
	memset(lpString, 0, 256);
	while(1)
	{
		nByte = CONACTORCOMPILER_GetByte();
		if(nByte == 0xFF)
		{
			return -1;
		}
		if(nByte != 0x20 && nByte != 0x00 && nByte != 0x0D && nByte != 0x0A)
		{
			CAC_nPos--;
			break;
		}
	}
	while(1)
	{
		nByte = CONACTORCOMPILER_GetByte();
		if(nByte == 0xFF)
		{
			return -1;
		}
		if(nByte == 0x20 || nByte == 0x00 || nByte == 0x0D || nByte == 0x0A)
		{
			while(1)
			{
				nByte = CONACTORCOMPILER_GetByte();
				if(nByte == 0xFF)
				{
					return -1;
				}
				if(nByte != 0x20 && nByte != 0x00 && nByte != 0x0D && nByte != 0x0A)
				{
					CAC_nPos--;
					break;
				}
			}
			break;
		}
		lpString[nStrPos++] = nByte;
	}
	return 0;
}

int CONACTORCOMPILER_IsNextStatementComparative()
{
	int i;
	int nOldPos = CAC_nPos;
	char lpstrStatement[256];
	CONACTORCOMPILER_GetNextString(lpstrStatement);
	for(i = 0x30; i < 0x40; i++)
	{
		if(Instructions[i].strSyntax)
		{
			if(!strnicmp(lpstrStatement, Instructions[i].strSyntax, strlen(lpstrStatement)))
			{
				CAC_nPos = nOldPos;
				return 1;
			}
		}
	}
	CAC_nPos = nOldPos;
	return 0;
}

void CONACTORCOMPILER_SkipFunction()
{
	int nCount = 1;
	unsigned char nByte;
	while(nCount)
	{
		nByte = CONACTORCOMPILER_GetByte();
		if(nByte == '{')
		{
			nCount++;
		}
		else if(nByte == '}')
		{
			nCount--;
		}
	}
}

void CONACTORCOMPILER_GetUntilLine(char *lpstrString)
{
	int nStrPos = 0;
	unsigned char nByte = 0;
	while(1)
	{
		nByte = CONACTORCOMPILER_GetByte();
		if(nByte != 0x0D && nByte != 0x0A)
		{
			lpstrString[nStrPos++] = nByte;
		}
		else
		{
			if(nByte == 0x0D)
			{
				CONACTORCOMPILER_GetByte();
			}
			break;
		}
	}
}

void CONACTORCOMPILER_AddSub(SUBROUTINE *s)
{
	CAC_nLastestSubroutine = CAC_nSubCount;
	memmove(&CAC_Subs[CAC_nSubCount++], s, sizeof(SUBROUTINE));
}

void CONACTORCOMPILER_SetupComparativeSubroutine(BOOL bBranch, SUBROUTINE *pParent)
{
	char strCurrent[256];
	SUBROUTINE s;
	s.nStartPos = CAC_nPos;
	CONACTORCOMPILER_GetNextString(strCurrent);
	if(!strcmp(strCurrent, "{"))
	{
		CONACTORCOMPILER_SkipFunction();
	}
	else
	{
		CAC_nPos = s.nStartPos;
		CONACTORCOMPILER_GetUntilLine(strCurrent);
	}
	s.nEndPos = CAC_nPos;
	if(bBranch)
	{
		CONACTORCOMPILER_SetByte(0x01);
	}
	else
	{
		CONACTORCOMPILER_SetByte(0x02);
	}
	s.nJMPAddress = CAC_nCodePos;
	s.nElseCase = 0;
	CAC_nCodePos += 2;
	if(pParent != NULL)
	{
		s.pScript = pParent->pScript;
	}
	else
	{
		s.pScript = NULL;
	}
	CONACTORCOMPILER_AddSub(&s);
}

void CONACTORCOMPILER_CompileStatement(char* strCurrent, int nDontAddJMP, SUBROUTINE *pParent)
{
	int i;
	int j;
	for(i = 0; i < 0x40; i++)
	{
		if(Instructions[i].strSyntax)
		{
			if(!strnicmp(strCurrent, Instructions[i].strSyntax, strlen(strCurrent)))
			{
				CONACTORCOMPILER_SetByte(i & 0xFF);
				for(j = 0; j < Instructions[i].nArgs; j++)
				{
					CONACTORCOMPILER_GetNextString(strCurrent);
					CONACTORCOMPILER_SetWord(CONACTORCOMPILER_GetValue(strCurrent));
				}
				if(i >= 0x30 && i <= 0x3F)
				{
					if(!nDontAddJMP)
					{
						CONACTORCOMPILER_SetupComparativeSubroutine(TRUE, pParent);
					}
				}
				break;
			}
		}
	}
}

void CONACTORCOMPILER_CompileFunction(SUBROUTINE *s)
{
	char strCurrent[256];
	unsigned _int8 *pOldScript;
	if(s != NULL)
	{
		CAC_nPos = s->nStartPos;
		CAC_nScriptSize = s->nEndPos;
		CAC_pCode[s->nJMPAddress] = CAC_nCodePos >> 8;
		CAC_pCode[s->nJMPAddress + 1] = CAC_nCodePos & 0xFF;
		if(s->pScript != NULL)
		{
			//For state compiling
			pOldScript = CAC_pScript;
			CAC_pScript = s->pScript;
		}
	}
	while(CONACTORCOMPILER_GetNextString(strCurrent) == 0)
	{
		if(!strcmp(strCurrent, "else"))
		{
			if(CONACTORCOMPILER_IsNextStatementComparative())
			{
				//kind of 'else if' syntax
				while(1)
				{
					CONACTORCOMPILER_GetNextString(strCurrent);
					CONACTORCOMPILER_CompileStatement(strCurrent, TRUE, s);
					if(!CONACTORCOMPILER_IsNextStatementComparative())
					{
						CONACTORCOMPILER_SetupComparativeSubroutine(TRUE, s);
						break;
					}
				}
			}
			else
			{
				CAC_Subs[CAC_nLastestSubroutine].nElseCase = 1;
				CONACTORCOMPILER_SetupComparativeSubroutine(FALSE, s);
			}
		}
		else
		{
			if(!strcmp("state", strCurrent))
			{
				CONACTORCOMPILER_GetNextString(strCurrent);
				if(!strcmp(strCurrent, "quikget"))
				{
					CONACTORCOMPILER_CompileState(strCurrent);
				}
				if(!strcmp(strCurrent, "quikweaponget"))
				{
					CONACTORCOMPILER_CompileState(strCurrent);
				}
				if(!strcmp(strCurrent, "randgetweapsnds"))
				{
					CONACTORCOMPILER_CompileState(strCurrent);
				}
			}
			else
			{
				CONACTORCOMPILER_CompileStatement(strCurrent, FALSE, s);
			}
		}
		CAC_nLastestAddress = CAC_nCodePos;
	}
	if(s == NULL)
	{
		CONACTORCOMPILER_SetByte(0x04);
	}
	if(s != NULL)
	{
		if(s->pScript != NULL)
		{
			//Restore the old script
			CAC_pScript = pOldScript;
		}
		CONACTORCOMPILER_SetByte(0x03);
		if(s->nElseCase)
		{
			CONACTORCOMPILER_SetWord(s->nJMPAddress + 5);
		}
		else
		{
			CONACTORCOMPILER_SetWord(s->nJMPAddress + 2);
		}
	}
}

/*void CONACTORCOMPILER_CompileState(char *strState)
{
	int i;
	unsigned _int8 *pScript;
	int nPos;
	int nSubCount = 0;
	int nLastestSubroutine = 0;
	int nScriptSize = 0;
	int nLastCodePos;
	SUBROUTINE	pSubs[0x20];

	//Save the state of our actor compiler
	pScript = CAC_pScript;
	nPos = CAC_nPos;
	nSubCount = CAC_nSubCount;
	nLastestSubroutine = CAC_nLastestSubroutine;
	nScriptSize = CAC_nScriptSize;
	memcpy(pSubs, CAC_Subs, sizeof(SUBROUTINE) * 0x20);
	
	
	//Search the number of our state
	for(i = 0; i < CAC_Context->nStateCount; i++)
	{
		if(!strcmp(CAC_Context->State[i].strName, strState))
		{
			break;
		}
	}

	//Change our variables
	CAC_pScript = (unsigned _int8*)CAC_Context->State[i].strCode;
	CAC_nPos = 0;
	CAC_nSubCount = 0;
	CAC_nLastestSubroutine = 0;

	
	//Save the last code position

	nLastCodePos = CAC_nLastestAddress;
	//Compile the function(s)
	CONACTORCOMPILER_CompileFunction(NULL);

	//Put a return to our old address
	//Remove the trailing '0x04' (END) and change it for an absolute jump (JMP)

	CAC_pCode[CAC_nCodePos - 1] = 0x03;
	CONACTORCOMPILER_SetWord(nLastCodePos);
	for(i = 0; i < CAC_nSubCount; i++)
	{
		CONACTORCOMPILER_CompileFunction(&CAC_Subs[i]);
	}

	//Restore the state
	CAC_pScript = pScript;
	CAC_nPos = nPos;
	CAC_nSubCount = nSubCount;
	CAC_nLastestSubroutine = nLastestSubroutine;
	CAC_nScriptSize = nScriptSize;
	memcpy(CAC_Subs, pSubs, sizeof(SUBROUTINE) * 0x20);
}*/

void CONACTORCOMPILER_CompileState(char *strState)
{
	SUBROUTINE s;
	int i;
	for(i = 0; i < CAC_Context->nStateCount; i++)
	{
		if(!strcmp(CAC_Context->State[i].strName, strState))
		{
			break;
		}
	}
	s.pScript = (unsigned char*)&CAC_Context->State[i].strCode[0];
	s.nElseCase = 0;
	s.nStartPos = 0;
	s.nEndPos = strlen(CAC_Context->State[i].strCode);
	//Humm, I shouldn't do this :\ (ends, ends, ends, ends, ends, ends, etc...)
	strcat((char*)s.pScript, " ends");
	CONACTORCOMPILER_SetByte(0x03);
	s.nJMPAddress = CAC_nCodePos;
	CAC_nCodePos += 2;
	CONACTORCOMPILER_AddSub(&s);
}


extern "C" void DLLEXPORT XBUILD_CONACTORCOMPILER_SetConscriptContext(XBUILD_CONSCRIPT_CONTEXT *c)
{
	CAC_Context = c;
}

extern "C" void DLLEXPORT XBUILD_CONACTORCOMPILER_Assemble(int nActor, unsigned char *pData)
{
	int i;
	CAC_pScript = (unsigned _int8*)CAC_Context->Actor[nActor].strCode;
	CAC_pCode = (unsigned _int8*)pData;
	CAC_nPos = 0;
	CAC_nCodePos = 0;
	CAC_nScriptSize = strlen((char*)CAC_pScript);
	CAC_nSubCount = 0;
	CAC_nLastestSubroutine = 0;
	CONACTORCOMPILER_CompileFunction(NULL);
	for(i = 0; i < CAC_nSubCount; i++)
	{
		CONACTORCOMPILER_CompileFunction(&CAC_Subs[i]);
	}
}