#include "COMMON.H"

char*		GRPMANAGER_lpstrMainfile;
long		GRPMANAGER_dwEndofList;
char		GRPMANAGER_str2ndSearch[128];

int GRPMANAGER_SetMainFile(char *filename)
{
	FILE *stream;
	stream = fopen(filename, "rb");
	if(!stream)
	{
		msgboxf(NULL, TITLE, 16, "Couldn't open '%s' for reading.\nPlease put '%s' in this game directory.", filename, filename);
		return 0;
	}
	GRPMANAGER_lpstrMainfile = filename;
	XBUILD_CONSOLE_PrintFormatted("Setting main GRP file for '%s'.\r\n", filename);
	fseek(stream, 0x0C, SEEK_SET);
	fread(&GRPMANAGER_dwEndofList, 4, 1, stream);
	GRPMANAGER_dwEndofList *= 0x10;
	GRPMANAGER_dwEndofList += 0x10;
	fclose(stream);
	return 1;
}

int GRPMANAGER_Seek(FILE *grp, char *file, unsigned _int32 *size)
{
	unsigned _int32 filepos;
	unsigned _int32 filesize;
	unsigned _int32 grpsize;
	int				tgrpsize;
	char			filename[12];
	bool			found = false;
	fseek(grp, 0, SEEK_END);
	grpsize = ftell(grp);
	tgrpsize = ftell(grp);
	fseek(grp, 0x0C, SEEK_SET);
	grpsize -= 0x0C;
	fread(&filepos, 4, 1, grp);
	grpsize -= 4;
	filepos <<= 4;
	filepos += 0x10;
	while(ftell(grp) < GRPMANAGER_dwEndofList)
	{
		fread(filename, 12, 1, grp);
		fread(&filesize, 4, 1, grp);
		grpsize -= 16;
		if(!strnicmp(filename, file, 12))
		{
			found = true;
			break;
		}
		filepos += filesize;
	}
	if(found)
	{
		fseek(grp, filepos, SEEK_SET);
		*size = filesize;
		return 1;
	}
	else
	{
		return 0;
	}
}

extern "C" int DLLEXPORT XBUILD_GRPMANAGER_ExtractFile(char *file, char *out)
{
	FILE *stream;
	char strPath[256];
	unsigned _int32 size;
	unsigned _int8 *buffer;
	strcpy(strPath, GRPMANAGER_str2ndSearch);
	strcat(strPath, file);
	stream = fopen(strPath, "rb");
	if(stream)
	{
		CopyFile(strPath, out, FALSE);
		return 1;
	}
	stream = fopen(GRPMANAGER_lpstrMainfile, "rb");
	if(!GRPMANAGER_Seek(stream, file, &size))
	{
		return 0;
	}
	buffer = new unsigned _int8[size];
	fread(buffer, size, 1, stream);
	fclose(stream);
	//Remove the read only flag
	if(GetFileAttributes(out) & FILE_ATTRIBUTE_READONLY)
	{
		SetFileAttributes(out, GetFileAttributes(out) & ~(FILE_ATTRIBUTE_READONLY));
	}
	stream = fopen(out, "wb");
	fwrite(buffer, size, 1, stream);
	fclose(stream);
	delete buffer;
	return 1;
}

extern "C" int DLLEXPORT XBUILD_GRPMANAGER_GetFileData(char *file, unsigned _int8 **pointer, unsigned _int32 *size)
{
	FILE *stream;
	unsigned _int32 fsize;
	stream = fopen(file, "rb");
	if(!stream)
	{
		char strFile[128];
		strcpy(strFile, GRPMANAGER_str2ndSearch);
		strcat(strFile, file);
		stream = fopen(strFile, "rb");
		if(!stream)
		{
			stream = fopen(GRPMANAGER_lpstrMainfile, "rb");
			if(!GRPMANAGER_Seek(stream, file, &fsize))
			{
				return 0;
			}
		}
		else
		{
			fseek(stream, 0, SEEK_END);
			fsize = ftell(stream);
			fseek(stream, 0, SEEK_SET);
		}
	}
	else
	{
		fseek(stream, 0, SEEK_END);
		fsize = ftell(stream);
		fseek(stream, 0, SEEK_SET);
	}
	*pointer = new unsigned _int8[fsize];
	fread(*pointer, fsize, 1, stream);
	*size = fsize;
	fclose(stream);
	return 1;
}

extern "C" void DLLEXPORT XBUILD_GRPMANAGER_SetSecondSearchDir(char *lpstrDir)
{
	strcpy(GRPMANAGER_str2ndSearch, lpstrDir);
}
