#include "COMMON.H"

extern "C" int DLLEXPORT XBUILD_MAP_Load(char *lpstrFile, MAP *lpMap)
{
	unsigned _int8 *lpData;
	unsigned _int32 nSize;
	unsigned _int32 nCounter = 0;
	int i;
	if(!XBUILD_GRPMANAGER_GetFileData(lpstrFile, &lpData, &nSize))
	{
		XBUILD_CONSOLE_PrintFormatted("Couldn't load map '%s'\r\n.", lpstrFile);
		return 0;
	}
	lpMap->Mapinfo.Version			= GETLONG(lpData, 0x00);
	lpMap->Mapinfo.StartX			= (signed)GETLONG(lpData, 0x04);
	lpMap->Mapinfo.StartY			= (signed)GETLONG(lpData, 0x08);
	lpMap->Mapinfo.StartZ			= ((signed)GETLONG(lpData, 0x0C)) >> 4;
	lpMap->Mapinfo.StartA			= GETWORD(lpData, 0x10);
	lpMap->Mapinfo.FirstSector		= GETWORD(lpData, 0x12);
	lpMap->Mapinfo.SectorNumber		= GETWORD(lpData, 0x14);
	nCounter = 0x16;
	for(i = 0; i < lpMap->Mapinfo.SectorNumber; i++)
	{
		lpMap->Sector[i].WallPointer	= GETWORD(lpData, nCounter + 0x00);
		lpMap->Sector[i].WallNumber		= GETWORD(lpData, nCounter + 0x02);
		lpMap->Sector[i].CZ				= (GETLONG(lpData, nCounter + 0x04)) >> 4;
		lpMap->Sector[i].FZ				= (GETLONG(lpData, nCounter + 0x08)) >> 4;
		lpMap->Sector[i].CStat			= GETWORD(lpData, nCounter + 0x0C);
		lpMap->Sector[i].FStat			= GETWORD(lpData, nCounter + 0x0E);
		lpMap->Sector[i].CPic			= GETWORD(lpData, nCounter + 0x10);
		lpMap->Sector[i].CHei			= GETWORD(lpData, nCounter + 0x12);
		lpMap->Sector[i].CShade			= (signed)lpData[nCounter + 0x14];
		lpMap->Sector[i].CPal			= lpData[nCounter + 0x15];
		lpMap->Sector[i].CPanX			= lpData[nCounter + 0x16];
		lpMap->Sector[i].CPanY			= lpData[nCounter + 0x17];
		lpMap->Sector[i].FPic			= GETWORD(lpData, nCounter + 0x18);
		lpMap->Sector[i].FHei			= GETWORD(lpData, nCounter + 0x1A);
		lpMap->Sector[i].FShade			= (signed)lpData[nCounter + 0x1C];
		lpMap->Sector[i].FPal			= lpData[nCounter + 0x1D];
		lpMap->Sector[i].FPanX			= lpData[nCounter + 0x1E];
		lpMap->Sector[i].FPanY			= lpData[nCounter + 0x1F];
		lpMap->Sector[i].Visibility		= lpData[nCounter + 0x20];
		lpMap->Sector[i].Filler			= lpData[nCounter + 0x21];
		lpMap->Sector[i].LoTag			= GETWORD(lpData, nCounter + 0x22);
		lpMap->Sector[i].HiTag			= GETWORD(lpData, nCounter + 0x24);
		lpMap->Sector[i].Extra			= GETWORD(lpData, nCounter + 0x26);
		nCounter += 0x28;
	}
	lpMap->Mapinfo.WallNumber = GETWORD(lpData, nCounter);
	nCounter += 2;
	for(i = 0; i < lpMap->Mapinfo.WallNumber; i++)
	{
		lpMap->Wall[i].X				= GETLONG(lpData, nCounter + 0x00);
		lpMap->Wall[i].Y				= GETLONG(lpData, nCounter + 0x04);
		lpMap->Wall[i].Point2			= GETWORD(lpData, nCounter + 0x08);
		lpMap->Wall[i].NextWall			= GETWORD(lpData, nCounter + 0x0A);
		lpMap->Wall[i].NextSector		= GETWORD(lpData, nCounter + 0x0C);
		lpMap->Wall[i].CStat			= GETWORD(lpData, nCounter + 0x0E);
		lpMap->Wall[i].Pic				= GETWORD(lpData, nCounter + 0x10);
		lpMap->Wall[i].OverPic			= GETWORD(lpData, nCounter + 0x12);
		lpMap->Wall[i].Shade			= (signed)lpData[nCounter + 0x14];
		lpMap->Wall[i].Pal				= lpData[nCounter + 0x15];
		lpMap->Wall[i].RepX				= lpData[nCounter + 0x16];
		lpMap->Wall[i].RepY				= lpData[nCounter + 0x17];
		lpMap->Wall[i].PanX				= lpData[nCounter + 0x18];
		lpMap->Wall[i].PanY				= lpData[nCounter + 0x19];
		lpMap->Wall[i].LoTag			= GETWORD(lpData, nCounter + 0x1A);
		lpMap->Wall[i].HiTag			= GETWORD(lpData, nCounter + 0x1C);
		lpMap->Wall[i].Extra			= GETWORD(lpData, nCounter + 0x1E);
		nCounter += 0x20;
	}
	lpMap->Mapinfo.SpriteNumber = GETWORD(lpData, nCounter);
	nCounter += 2;
	for(i = 0; i < lpMap->Mapinfo.SpriteNumber; i++)
	{
		lpMap->Sprite[i].X				= GETLONG(lpData, nCounter + 0x00);
		lpMap->Sprite[i].Y				= GETLONG(lpData, nCounter + 0x04);
		lpMap->Sprite[i].Z				= (GETLONG(lpData, nCounter + 0x08)) >> 4;
		lpMap->Sprite[i].CStat			= GETWORD(lpData, nCounter + 0x0C);
		lpMap->Sprite[i].Pic			= GETWORD(lpData, nCounter + 0x0E);
		lpMap->Sprite[i].Shade			= lpData[nCounter + 0x10];
		lpMap->Sprite[i].Palette		= lpData[nCounter + 0x11];
		lpMap->Sprite[i].Clipdist		= lpData[nCounter + 0x12];
		lpMap->Sprite[i].Filler			= lpData[nCounter + 0x13];
		lpMap->Sprite[i].RepX			= lpData[nCounter + 0x14];
		lpMap->Sprite[i].RepY			= lpData[nCounter + 0x15];
		lpMap->Sprite[i].OffX			= lpData[nCounter + 0x16];
		lpMap->Sprite[i].OffY			= lpData[nCounter + 0x17];
		lpMap->Sprite[i].SectorNum		= GETWORD(lpData, nCounter + 0x18);
		lpMap->Sprite[i].StatNum		= GETWORD(lpData, nCounter + 0x1A);
		lpMap->Sprite[i].Angle			= GETWORD(lpData, nCounter + 0x1C);
		lpMap->Sprite[i].Owner			= GETWORD(lpData, nCounter + 0x1E);
		lpMap->Sprite[i].VelX			= GETWORD(lpData, nCounter + 0x20);
		lpMap->Sprite[i].VelY			= GETWORD(lpData, nCounter + 0x22);
		lpMap->Sprite[i].VelZ			= GETWORD(lpData, nCounter + 0x24);
		lpMap->Sprite[i].LoTag			= GETWORD(lpData, nCounter + 0x26);
		lpMap->Sprite[i].HiTag			= GETWORD(lpData, nCounter + 0x28);
		lpMap->Sprite[i].Extra			= GETWORD(lpData, nCounter + 0x2A);
		nCounter += 0x2C;
	}
	return 1;
}