#ifndef _XBUILDREN_H_
#define _XBUILDREN_H_


#define XBUILDDISPLAYLIST_TYPE_TILE		0x01
#define XBUILDDISPLAYLIST_TYPE_MESH		0x02
#define XBUILDDISPLAYLIST_TYPE_32BITS	0x03
#define	XBUILDDISPLAYLIST_TYPE_FILTER	0x04

struct XBUILDDISPLAYELEMENT_TILE
{
	unsigned _int32		dwX;
	unsigned _int32		dwY;
	unsigned _int32		dwTile;
};

struct XBUILDDISPLAYELEMENT_MESH
{
	unsigned _int32		dwX;
	unsigned _int32		dwY;
	char				pFilename[56];
};

struct XBUILDDISPLAYELEMENT_32BITS
{
	unsigned _int32		dwX;
	unsigned _int32		dwY;
	char*				pStream;
};

struct XBUILDDISPLAYELEMENT_FILTER
{
	unsigned _int8 R;
	unsigned _int8 G;
	unsigned _int8 B;
	unsigned _int8 A;
};

struct XBUILDDISPLAYELEMENT
{
	unsigned _int32		dwType;
	unsigned _int8		pData[0x40];
};

struct XBUILDDISPLAYLIST
{
	XBUILDDISPLAYELEMENT	Element[512];
	unsigned _int32			dwReferentialX;
	unsigned _int32			dwReferentialY;
	int						nElementCount;
};

struct XBUILDRENCONTEXT
{
	int		(*Initialize)(HWND hWnd);
	void	(*Config)();
	void	(*About)();
	void	(*Destroy)();
	void	(*DrawMap)(int X, int Y, int Z, int XRot, int YRot);
	void	(*PrepareMap)(void *lpMap);
	void	(*SwapDisplayBuffers)();
	void	(*ProcessDisplayList)(void*);
	void*	(*GetMapAddress)(void);
	int		(*IsFullScreen)();
	int		(*GetWidth)();
	int		(*GetHeight)();
	void	(*SetMeshForTile)(int, char*, float);
	void	(*TakeScreenShot)(char*);
	char	Description[256];
	char	Author[256];
	char	Version[256];
};

#endif